#include <signal.h>
#include <sys/types.h>
#include <unistd.h>
#include "installer.h"
#include "helps.h"

struct tgt_object *window, *desktop, *stbar, *popup;
char confile[300];
void *conf;
int server_edition = 0;
int firewall_edition = 0;
int helpnum = 0;

int licenc_main();
int preinst1_main();
int part3_main();

void help(int hnum) {
	//char *helps[] = {"Ez a help\n\n","Ez a masik help\n\n"};
	tgt_easyrequest(desktop,"Segitseg",helps[hnum],"  OK  ");
}

void off() {
	tgt_destroyobject(desktop);
	printf("Kilps!\n");
	exit(0);
}

void hotkeys(struct tgt_object *obj, char k) {
	if (k == 's') { help(helpnum); }
	else if (k == TGT_KEY_ESC) { off(); }
}

void textarea(char *file) {
    FILE *f;
	struct tgt_object *texts;
    char text[71];
	int i = 2;
    
    if ( (f = fopen(file,"r")) ) {
    
	while ( (fgets(text,71,f) != NULL ) ) {
	 
	 texts = tgt_createandlink(window,TGT_CLASS_LABEL, (tgtt[]) {
	 TGTT_X,2,TGTT_FG,6,TGTT_END,0}); 
	 tgt_set(texts,TGTT_LABEL_TEXT, (tgtt) text);
	 tgt_set(texts,TGTT_Y, (tgtt) i);
	 i++;
	}
    
    } else { 
	 tgt_easyrequest(window,"Hiba",file,"[ Ok ]"); 
	 tgt_unlink(window);
	 tgt_destroyobject(desktop);
	 exit(1);
	}
}

void popupmsg(char *title, char *msg) {
	tgt_easyrequest(window,title,msg,"[ Ok ]");
}


int statusbar() {

	static char text[]={"Mozgs: Tab, <--> kurzor billentyk, Bevitel: enter, Kilps: ESC, Segtsg: s"};	

	stbar = tgt_createandlink(desktop,TGT_CLASS_STATUS, (tagitem[]) { 
	TGTT_FG,7,TGTT_BG,1,
	TGTT_STATUS_TEXT,(tgtt)	text,
	TGTT_STATUS_TYPE,0,
	TGT_STATUSF_ALIGNED,
	TGTT_END,0});
	
	tgt_set(desktop,TGTT_DESKTOP_HIDECURSOR,1);
	tgt_refresh(desktop);
	tgt_chtimes(0,100000);
	tgt_waitkeys(desktop);
	return(1);
}

void stbarch(char *txt) {
	
	tgt_set(stbar,TGTT_STATUS_TEXT,(tgtt) txt);
	tgt_refresh(desktop);
}

int main(int argc, char *argv[]) {
	int opt, start = 0;
	
	setenv("TERM","linux",1);
			
	while ( (opt = getopt(argc,argv,"sfpc:")) != -1) {
	
		switch(opt) {
	
		case 's': server_edition = 1;
			break;
		case 'f': firewall_edition = 1;
			break;
		case 'c': sprintf(confile,"%s",optarg); start = 1;		
			break;
		case 'p': start = 2;			
			break;
		case '?': printf("hasznalat: uhu-tgt-installer [-s] [-f] [-c config file]\n"); exit(1);
			break;
		
		}
	}	
	
		
	desktop = tgt_start(NULL);
	
	if ( !start) {
	 sprintf(confile,"/tmp/uhu-tgt-installer.conf"); start = 0;	
	 remove(confile);
	 licenc_main();	 
	} else if ( start == 1) { 
	 preinst1_main();			
    } else if ( start == 2 ) { 
	 part3_main();
	}
		
	statusbar(); 
	
	return(0);
	
}
